﻿<%@ WebHandler Language="C#" Class="urlredirection" %>

using System;
using System.Web;
using MongoDB.Driver;
using MongoDB.Bson;
using Silmoon.DNS.ControlCore;

public class urlredirection : IHttpHandler
{

    public void ProcessRequest(HttpContext context)
    {
        //context.Response.ContentType = "text/plain";
        string host = context.Request.ServerVariables["HTTP_HOST"];
        string path = context.Request.QueryString["path"];

        string[] configureLine = System.IO.File.ReadAllLines(System.Configuration.ConfigurationManager.AppSettings["configureFile"]);
        System.Collections.Specialized.NameValueCollection parameters = Silmoon.SmString.AnalyzeNameValue(configureLine, "=", "");

        DataAccessInfo.MongoDB_database = parameters["db_mongodb_database"];
        DataAccessInfo.MongoDB_monitor_database = parameters["db_mongodb_monitor_database"];
        DataAccessInfo.MongoDB_username = parameters["db_mongodb_username"];
        DataAccessInfo.MongoDB_password = parameters["db_mongodb_password"];
        DataAccessInfo.MongoDB_server = parameters["db_mongodb_server"];

        MongoConnectionStringBuilder stringBuilder = new MongoConnectionStringBuilder();
        stringBuilder.Username = DataAccessInfo.MongoDB_username;
        stringBuilder.Password = DataAccessInfo.MongoDB_password;
        stringBuilder.Server = new MongoServerAddress(DataAccessInfo.MongoDB_server);
        stringBuilder.DatabaseName = DataAccessInfo.MongoDB_database;
        stringBuilder.SlaveOk = true;

        MongoServer server = MongoServer.Create(stringBuilder);
        MongoDatabase db = server.GetDatabase(DataAccessInfo.MongoDB_database);
        MongoCollection collection = db.GetCollection("records");
        QueryDocument query = new QueryDocument("fqdn", host + ".");
        BsonDocument document = collection.FindOneAs<BsonDocument>(query);
        if (document != null)
        {
            string url = document["url"].AsString;
            if (document["accuredirect"].AsBoolean)
                url = url + path.Substring(1, path.Length - 1);
            context.Response.Redirect(url);
        }
        else
        {
            context.Response.Write("无效的Url转发。");
        }
        server.Disconnect();
    }

    public bool IsReusable
    {
        get
        {
            return false;
        }
    }

}